package net.locusworks.logger;

import static java.nio.charset.StandardCharsets.UTF_8;

import java.io.ByteArrayOutputStream;
import java.io.PrintStream;

@ApplicationLoggerInfo(name="System.Debug", defaultLevel=LogLevel.DEBUG)
public class SystemDebugLogger extends PrintStream {
  
  private ApplicationLogger logger;
  
  public SystemDebugLogger() {
    this(ApplicationLoggerFactory.getLogger(SystemDebugLogger.class));
  }
  
  public SystemDebugLogger(ApplicationLogger logger) {
    super(new ByteArrayOutputStream());
    this.logger = logger;
  }
  
  @Override
  public void write(byte[] b) {
    logger.debug(new String(b, UTF_8));
  }

  @Override
  public void write(byte[] b, int off, int len) {
    logger.debug(new String(b, off, len, UTF_8));
  }

  @Override
  public void write(int b) {
    write(new byte[] { (byte)b });
  }
}
