package net.locusworks.logger;

import static java.nio.charset.StandardCharsets.UTF_8;

import java.io.ByteArrayOutputStream;
import java.io.PrintStream;

@ApplicationLoggerInfo(name="System.Out", defaultLevel=LogLevel.OFF)
public class SystemOutLogger extends PrintStream {
  
  private ApplicationLogger logger;
  
  public SystemOutLogger() {
    this(ApplicationLoggerFactory.getLogger(SystemOutLogger.class));
  }
  
  public SystemOutLogger(ApplicationLogger logger) {
    super(new ByteArrayOutputStream());
    this.logger = logger;
  }
  
  @Override
  public void write(byte[] b) {
    logger.info(new String(b, UTF_8));
  }

  @Override
  public void write(byte[] b, int off, int len) {
    logger.info(new String(b, off, len, UTF_8));
  }

  @Override
  public void write(int b) {
    write(new byte[] { (byte)b });
  }
}
